package com.io.yutian.refinesystem;

import com.io.yutian.refinesystem.gui.GuiHolder;
import com.io.yutian.refinesystem.gui.RefineGui;
import com.io.yutian.refinesystem.listener.GuiListener;
import de.tr7zw.itemnbtapi.NBTItem;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.ArrayList;
import java.util.List;

public final class RefineSystem extends JavaPlugin {

    private static RefineSystem instance;

    @Override
    public void onEnable() {
        instance = this;
        Bukkit.getPluginManager().registerEvents(new GuiListener(), this);

        RefineSystemSetting.reload();
    }

    @Override
    public void onDisable() {
        for (Player player : Bukkit.getOnlinePlayers()) {
            if (player.getOpenInventory() != null) {
                InventoryHolder inventoryHolder = player.getOpenInventory().getTopInventory().getHolder();
                if (inventoryHolder instanceof GuiHolder) {
                    player.closeInventory();
                }
            }
        }
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (args.length == 1 && args[0].equalsIgnoreCase("reload") && sender.isOp()) {
            RefineSystemSetting.reload();
            sender.sendMessage("§8§l[§a§l!§8§l] §7重载成功");
            return true;
        }
        if (args.length == 1 && args[0].equalsIgnoreCase("item") && sender.isOp()) {
            Player player = (Player) sender;
            ItemStack itemStack = new ItemStack(Material.IRON_PICKAXE);
            List<String> lores = new ArrayList<>();
            lores.add("§f品质: §b稀有");
            lores.add("§7- < §1§5§r§7尚未进行洗炼§1§5§r§7 >");
            ItemMeta itemMeta = itemStack.getItemMeta();
            itemMeta.setLore(lores);
            itemStack.setItemMeta(itemMeta);
            player.getInventory().addItem(itemStack);
            ItemStack itemStack1 = new ItemStack(Material.PAPER);
            ItemMeta itemMeta1 = itemStack1.getItemMeta();
            itemMeta1.setDisplayName("§f雨天洗炼符");
            itemStack1.setItemMeta(itemMeta1);
            NBTItem item = new NBTItem(itemStack1);
            item.setString("refineType", "雨天洗炼符");
            player.getInventory().addItem(item.getItem());
            ItemStack itemStack2 = new ItemStack(Material.EMERALD);
            ItemMeta itemMeta2 = itemStack2.getItemMeta();
            itemMeta2.setDisplayName("§f雨天去除洗炼符");
            itemStack2.setItemMeta(itemMeta1);
            NBTItem item2 = new NBTItem(itemStack2);
            item2.setString("removeRefine", "true");
            player.getInventory().addItem(item2.getItem());
            sender.sendMessage("§8§l[§a§l!§8§l] §7获取物品成功");
            return true;
        }
        if (!(sender instanceof Player)) {
            return true;
        }
        Player player = (Player) sender;
        new RefineGui(player).open();
        return true;
    }

    public static RefineSystem inst() {
        return instance;
    }

}
