package com.io.yutian.refinesystem.data;

import java.util.HashMap;
import java.util.Map;

public class RefineData {

    private String id;
    private double chance;
    private int needQuality;
    private int minGlossaryAmount;
    private int maxGlossaryAmount;

    private Map<String, SkillData> skillDatas;

    protected final Map<String, Double> skillChances = new HashMap<>();

    public RefineData(String id, double chance, int needQuality, int minGlossaryAmount, int maxGlossaryAmount, Map<String, SkillData> skillDatas) {
        this.id = id;
        this.chance = chance;
        this.needQuality = needQuality;
        this.minGlossaryAmount = minGlossaryAmount;
        this.maxGlossaryAmount = maxGlossaryAmount;
        this.skillDatas = skillDatas;
        for (SkillData sd : skillDatas.values()) {
            skillChances.put(sd.getId(), sd.getChance());
        }
    }

    public String getId() {
        return id;
    }

    public double getChance() {
        return chance;
    }

    public int getNeedQuality() {
        return needQuality;
    }

    public int getMinGlossaryAmount() {
        return minGlossaryAmount;
    }

    public int getMaxGlossaryAmount() {
        return maxGlossaryAmount;
    }

    public Map<String, SkillData> getSkillDatas() {
        return skillDatas;
    }

    public Map<String, Double> getSkillChances() {
        return skillChances;
    }

    @Override
    public String toString() {
        return "RefineData{" +
                "id='" + id + '\'' +
                ", chance=" + chance +
                ", needQuality=" + needQuality +
                ", minGlossaryAmount=" + minGlossaryAmount +
                ", maxGlossaryAmount=" + maxGlossaryAmount +
                ", skillDatas=" + skillDatas +
                '}';
    }
}
