package com.io.yutian.refinesystem.data;

import com.io.yutian.refinesystem.util.RandomUtil;
import com.io.yutian.refinesystem.util.StringUtil;

public class SkillData {

    private String id;
    private double chance;
    private int minLevel;
    private int maxLevel;
    private double minTrigger;
    private double maxTrigger;

    public SkillData(String id, double chance, int minLevel, int maxLevel, double minTrigger, double maxTrigger) {
        this.id = id;
        this.chance = chance;
        this.minLevel = minLevel;
        this.maxLevel = maxLevel;
        this.minTrigger = minTrigger;
        this.maxTrigger = maxTrigger;
    }

    public String randomSkillLore() {
        int level = RandomUtil.getRandomInt(minLevel, maxLevel);
        double trigger = RandomUtil.getRandomDouble(minTrigger, maxTrigger, 1);
        return "§f§0§4§r"+id+" "+ StringUtil.intToRoman(level) +"§0§4§r§f §8| §f§0§5§r§f"+trigger+"§0§5§r§f% §7(被动技)";
    }

    public String getId() {
        return id;
    }

    public double getChance() {
        return chance;
    }

    public int getMinLevel() {
        return minLevel;
    }

    public int getMaxLevel() {
        return maxLevel;
    }

    public double getMinTrigger() {
        return minTrigger;
    }

    public double getMaxTrigger() {
        return maxTrigger;
    }

    @Override
    public String toString() {
        return "SkillData{" +
                "id='" + id + '\'' +
                ", chance=" + chance +
                ", minLevel=" + minLevel +
                ", maxLevel=" + maxLevel +
                ", minTrigger=" + minTrigger +
                ", maxTrigger=" + maxTrigger +
                '}';
    }
}
