package com.io.yutian.refinesystem.gui;

import com.io.yutian.refinesystem.util.PlayerInventoryUtil;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

public class RefineResultGui implements InventoryHolder, GuiHolder {

    private static final int[] ARRAY_1 = new int[] {0,8,9,17,18,26};
    private static final int[] ARRAY_2 = new int[] {1,2,3,5,6,7,10,11,15,16,19,20,21,23,24,25};
    private static final int[] ARRAY_3 = new int[] {4,12,14,22};

    private static final ItemStack ITEM_1;
    private static final ItemStack ITEM_2;
    private static final ItemStack ITEM_3;

    private static final int SLOT = 13;

    private Inventory inventory;
    private Player player;

    private ItemStack result;

    public RefineResultGui(Player player, ItemStack result) {
        this.player = player;
        this.result = result;
        this.inventory = Bukkit.createInventory(this, 27, "洗练界面");
        for (int i : ARRAY_1) {
            inventory.setItem(i, ITEM_1);
        }
        for (int i : ARRAY_2) {
            inventory.setItem(i, ITEM_2);
        }
        for (int i : ARRAY_3) {
            inventory.setItem(i, ITEM_3);
        }
        this.inventory.setItem(SLOT, result);
    }

    @Override
    public void onClick(InventoryClickEvent event) {
        event.setCancelled(true);
        Inventory clickedInventory = event.getClickedInventory();
        int slot = event.getRawSlot();
        if (slot == SLOT) {
            PlayerInventoryUtil.giveItemStack(player, result);
            player.playSound(player.getLocation(), Sound.UI_BUTTON_CLICK, 1, 1);
            result = null;
            player.closeInventory();
        }
    }

    @Override
    public void onClose(InventoryCloseEvent event) {
        if (result != null) {
            PlayerInventoryUtil.giveItemStack(player, result);
        }
    }

    @Override
    public void open() {
        player.openInventory(inventory);
    }

    @Override
    public Inventory getInventory() {
        return inventory;
    }

    static {
        ITEM_1 = new ItemStack(Material.STAINED_GLASS_PANE, 1, (short) 15);
        ITEM_2 = new ItemStack(Material.STAINED_GLASS_PANE, 1, (short) 0);
        ITEM_3 = new ItemStack(Material.STAINED_GLASS_PANE, 1, (short) 5);
        ItemMeta itemMeta1 = ITEM_1.getItemMeta();
        itemMeta1.setDisplayName(" ");
        ITEM_1.setItemMeta(itemMeta1);
        ItemMeta itemMeta2 = ITEM_2.getItemMeta();
        itemMeta2.setDisplayName("");
        ITEM_2.setItemMeta(itemMeta2);
        ItemMeta itemMeta3 = ITEM_3.getItemMeta();
        itemMeta3.setDisplayName(" ");
        ITEM_3.setItemMeta(itemMeta3);
    }

}
