package com.io.yutian.refinesystem.listener;

import com.io.yutian.refinesystem.RefineSystemSetting;
import com.io.yutian.refinesystem.gui.GuiHolder;
import com.io.yutian.refinesystem.util.ItemStackUtil;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.inventory.ItemStack;

public class GuiListener implements Listener {

    @EventHandler
    public void onInventoryClick(InventoryClickEvent event) {
        Inventory inventory = event.getInventory();
        InventoryHolder holder = inventory.getHolder();
        if (holder != null && holder instanceof GuiHolder) {
            GuiHolder guiHolder = (GuiHolder) holder;
            guiHolder.onClick(event);
            return;
        }
        onClick(event);
    }

    private void onClick(InventoryClickEvent event) {
        if (event.getInventory().getType() == InventoryType.CRAFTING) {
            ItemStack cursor = event.getCursor();
            if (!ItemStackUtil.isRemoveRefineItem(cursor)) {
                return;
            }
            ItemStack current = event.getCurrentItem();
            if (current == null || current.getType() == Material.AIR) {
                return;
            }
            event.setCancelled(true);
            Player player = (Player) event.getWhoClicked();
            if (!ItemStackUtil.isRefined(current)) {
                player.sendMessage("§8§l[§c§l!§8§l] §7该物品无法重置洗练");
                player.playSound(player.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1.6F, 1.8F);
                return;
            }
            if (cursor.getAmount() == 1) {
                event.getWhoClicked().setItemOnCursor(null);
            } else {
                cursor.setAmount(cursor.getAmount() - 1);
            }
            ItemStack newItemStack = ItemStackUtil.replaceAllLore(current, RefineSystemSetting.getDetectionLore());
            event.setCurrentItem(newItemStack);
            player.playSound(player.getLocation(), Sound.ENTITY_PLAYER_LEVELUP, 1, 1);
            player.sendMessage("§8§l[§a§l!§8§l] §7成功重置洗练");
        }
    }

    @EventHandler
    public void onInventoryClose(InventoryCloseEvent event) {
        Inventory inventory = event.getInventory();
        InventoryHolder holder = inventory.getHolder();
        if (holder != null && holder instanceof GuiHolder) {
            GuiHolder guiHolder = (GuiHolder) holder;
            guiHolder.onClose(event);
        }
    }

}